<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['dk:BorrowStatus:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['dk:BorrowStatus:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['dk:BorrowStatus:remove']"
        >删除</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="BorrowStatusList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="状态编码" align="center" prop="id" min-width="20" />
      <el-table-column label="是否打款" align="center" prop="usedRemit" min-width="20">
        <template v-slot="scope">
          <dict-tag-v2 :options="yesOrNoList" :value="scope.row.usedRemit"/>
        </template>
      </el-table-column>
      <el-table-column label="允许提现" align="center" prop="withdrawFlag" min-width="20">
        <template v-slot="scope">
          <dict-tag-v2 :options="booleanList" :value="scope.row.withdrawFlag"/>
        </template>
      </el-table-column>
      <el-table-column label="借款状态" align="center" prop="borrowName" min-width="20">
        <template v-slot="scope">
          <span :style={color:scope.row.borrowNameStyle}>{{scope.row.borrowName}}</span>
        </template>
      </el-table-column>
      <el-table-column label="借款说明" align="center" prop="borrowRemark" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width" min-width="20">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['dk:BorrowStatus:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['dk:BorrowStatus:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改借款状态对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="字体颜色" prop="borrowNameStyle">
          <el-input v-model="form.borrowNameStyle" placeholder="请输入字体颜色" />
        </el-form-item>
        <el-form-item label="借款状态" prop="borrowName">
          <el-input v-model="form.borrowName" placeholder="请输入借款状态" />
        </el-form-item>
        <el-form-item label="借款说明" prop="borrowRemark">
          <el-input v-model="form.borrowRemark" type="textarea" placeholder="请输入内容" />
        </el-form-item>
        <el-form-item label="是否打款" prop="usedRemit">
          <el-radio-group v-model="form.usedRemit" fill="green" size="mini">
            <el-radio :label="1"  border>是</el-radio>
            <el-radio :label="0" border>否</el-radio>
          </el-radio-group>
        </el-form-item>
        <el-form-item label="允许提现" prop="withdrawFlag">
          <el-radio-group v-model="form.withdrawFlag" fill="green" size="mini">
            <el-radio :label="true" border>是</el-radio>
            <el-radio :label="false" border>否</el-radio>
          </el-radio-group>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button :loading="buttonLoading" type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  listBorrowStatus,
  getBorrowStatus,
  delBorrowStatus,
  addBorrowStatus,
  updateBorrowStatus,
  exportBorrowStatus,
} from '@/api/dk/BorrowStatus'
import { booleanList, yesOrNoList } from '@/constant/statusMap'

export default {
  name: "BorrowStatus",
  components: {
  },
  data() {
    return {
      yesOrNoList,booleanList,
      //按钮loading
      buttonLoading: false,
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 借款状态表格数据
      BorrowStatusList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        usedRemit: undefined,
        borrowName: undefined,
        borrowRemark: undefined,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        usedRemit: [
          { required: true, message: "是否可以打款不能为空", trigger: "blur" }
        ],
        borrowName: [
          { required: true, message: "借款状态不能为空", trigger: "blur" }
        ],
        borrowRemark: [
          { required: true, message: "借款说明不能为空", trigger: "blur" }
        ],
      }
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询借款状态列表 */
    getList() {
      this.loading = true;
      listBorrowStatus(this.queryParams).then(response => {
        this.BorrowStatusList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: undefined,
        usedRemit: undefined,
        borrowName: undefined,
        borrowRemark: undefined,
        borrowNameStyle: undefined,
        withdrawFlag: undefined,
        createTime: undefined,
        updateTime: undefined
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加借款状态";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.loading = true;
      this.reset();
      const id = row.id || this.ids
      getBorrowStatus(id).then(response => {
        this.loading = false;
        this.form = response.data;
        this.open = true;
        this.title = "修改借款状态";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          this.buttonLoading = true;
          if (this.form.id != null) {
            updateBorrowStatus(this.form).then(response => {
              this.buttonLoading = false;
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addBorrowStatus(this.form).then(response => {
              this.buttonLoading = false;
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm('是否确认删除借款状态编号为"' + ids + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
          this.loading = true;
          return delBorrowStatus(ids);
        }).then(() => {
          this.loading = false;
          this.getList();
          this.$modal.msgSuccess("删除成功");
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有借款状态数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
          this.exportLoading = true;
          return exportBorrowStatus(queryParams);
        }).then(response => {
          this.download(response.msg);
          this.exportLoading = false;
        }).catch(() => {});
    }
  }
};
</script>
